//
//  THMenu.java
//  treehousestudio
//
//  Created by Maxwell Planck on Tue Jan 07 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.util.*;
import java.awt.*;

import menuitems.*;

public class THMenu extends hb {

    public Vector menuitems;
    private final int space = 8;
    
    public THMenu(String s, int x, int y, int w, int h) {
        super(s, x, y, w, h, hb.MENU);

        menuitems = new Vector();
    }

    /**
     * This method adds the specified menuitem to the menu in the order it was called in the code
     */
    public void addMenuItem(menuitems.THMenuItem mi) {
        menuitems.addElement(mi);
    }

    /**
     * This method resets the menuitems so that this particular menu doesn't have any items
     */
    public void resetMenu() {
        menuitems = new Vector();
    }


    /**
     * This method draws a menu that is not unfolded
     */
    public void draw(Graphics gi) {
        this.placeString(gi);
    }
    
    /**
     * This method draws the menu.  Since it is a drawing method, it takes in the Graphics object
     * that handles all rendering within the Applet.  This method also returns the current menuitem selected
     */
    public THMenuItem unfold(Graphics gi) {

        THMenuItem mitem = null;
        int leading = 4;
        
        FontMetrics fm = gi.getFontMetrics();
        int spaceperitem = fm.getHeight() + leading;
        int fd = fm.getDescent();
        int fh = fm.getHeight();

        int maxw = 0, w, i;
        for(i=0;i < menuitems.size();i++) {
            String s = ((THMenuItem) menuitems.elementAt(i)).getName();
            w= fm.stringWidth(s);
            if (w > maxw) maxw = w;
        }

        // Draw menu box with white interior and black border
        gi.setColor(Color.white);
        gi.fillRect(cx, ch, maxw+space*2, menuitems.size()*spaceperitem);
        gi.setColor(Color.black);
        gi.drawRect(cx, ch, maxw+space*2, menuitems.size()*spaceperitem);

        int y;
        for(i=0, y=ch; i < menuitems.size(); i++, y+=spaceperitem) {
            THMenuItem currMI = (THMenuItem) menuitems.elementAt(i);
            String name = currMI.getName();
            if (name.equals("-")) {
                gi.setColor(Color.lightGray);
                gi.drawLine(cx+3,y+spaceperitem/2,cx+maxw+space*2-3,y+spaceperitem/2);
                gi.setColor(Color.black);
            } else {
                gi.drawString(name, cx+space, y-fd+spaceperitem-1);
                if (inrectp(cx, y, maxw+2*space, spaceperitem)) {
                    gi.setColor(Color.black);
                    gi.fillRect(cx+1,y+1,maxw+space*2-1,spaceperitem);
                    gi.setColor(Color.white);
                    gi.drawString(name,cx+space,y-fd+spaceperitem-1);
                    gi.setColor(Color.black);
                    mitem = currMI;
                }
            }
        }

        return mitem;
    }

    /**
     * Returns true if the mouse is currently within the specified rectangle- characterized by top left
     * coordinates and a width and height.  The mouse position is retrieved from the Applet class.
     */

    public boolean inrectp(int x, int y, int w, int h)
    {
        int[] mPos = Treehousestudio.reportMousePos();
        int mx = mPos[0]; int my = mPos[1];
        int s = 0;
        return (mx>x-s&&mx<x+w+s&&my>y-s&&my<y+h+s);
    }
}
