//
//  Treehousestudio.java
//  A simple Java applet
//

import java.awt.*;
import java.applet.*;
import java.util.*;

import hb;
import painthb;
import iconhb;
import THMenu;
import menuitems.*;

public class Treehousestudio extends Applet {

    /***********************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** All of the following code can be modified to update the current Tree House Studio
    ** Applet so functionality can be added to the menu bar
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/

    public void initMenus() {

        THMenu fileMenu = menubar.addMenu("File");
        fileMenu.addMenuItem(new SaveMenuItem(mainhb, gi, this));
        fileMenu.addMenuItem(new OpenMenuItem());

        THMenu editMenu = menubar.addMenu("Edit");
        editMenu.addMenuItem(new UndoMenuItem());
        editMenu.addMenuItem(new Spacer());
        editMenu.addMenuItem(new CutMenuItem());
        editMenu.addMenuItem(new CopyMenuItem());
        editMenu.addMenuItem(new PasteMenuItem());
        editMenu.addMenuItem(new Spacer());
        editMenu.addMenuItem(new ShowClipboardMenuItem());
    }
    
    /************************************************************************************
     ************************************************************************************
     ************************************************************************************
     **
     ** Everything else beyond this point is internal and shouldn't be changed unless
     ** you want to change an underlying aspect of the Applet.  Do use the rest of this code
     ** to understand how to add to the Applet.
     **
     ************************************************************************************
     ************************************************************************************
     ************************************************************************************/
    Image im=null;
    
    // Two sets of graphics
    Graphics gi;
    Graphics cg;
    
    int cbw, cbh;
    
    Vector bv = new Vector();
    Hashtable bh = new Hashtable();

    hb mhithb;
    private int mbarh = 18;

    // These are the main components of the applet
    painthb mainhb;
    Menubar menubar;
    iconhb ib;
    colorhb colhb;

    Font menufont;
    FontMetrics fm;
    
    // These are the static variables that can be referenced by a call to reportMousePos
    static int mx = 0, my = 0;

    public void init() {
        setLayout (null);
    }

    public void appendhb(hb a)
    {
        bv.addElement(a);
        bh.put(a.cs,a);
    }

    /**
     * This method returns the hb that the mouse is within considering that it searches down to the most
     * specific child and if overlapping occurs, returns the first one to be added to the list
     * of hbs
     **/
    public hb hithb(int x, int y)
    {
        int i;
        hb a, res;
        for(i=0;i<bv.size();i++) {
            a = (hb) bv.elementAt(i);
            if (a.insidep(x,y)) {
                return rechithb(a, x, y);
            }
        }
        return null;
    }

    private hb rechithb(hb a, int x, int y) {
        if (a.hasChildren()) {
            for (int i=0;i<a.children.size();i++) {
                hb currChild = (hb) a.children.get(i);
                if (currChild.insidep(x, y)) {
                    return rechithb(currChild, x, y);
                }
            }
        }
        return a;
    }
    
    /** --------------------------------
     * These methods are all used to handle mouse actions
     *  -------------------------------- */
    
    public boolean mouseDown(Event ev, int x, int y) {
        mx = x;
        my = y;
        mhithb = hithb(x,y);
        if (mhithb!=null) {
            System.out.println("hits: " + mhithb.cs);
            switch (mhithb.type) {
                case hb.MENU: 
                    redraw();
                    menubar.dropMenu(mhithb, x, y);
                    displayGraphics();
                    break;
                case hb.MAIN:
                    ((painthb) mhithb).mouseDown(ev,x,y);
                    ((painthb) mhithb).draw(cg);
                    break;
                case hb.MENUBAR:
                    break;
                default:
                    mhithb.mouseDown(ev,x,y);
                    mhithb.draw(cg);
            }
        }
        
        return true;
    }

    public boolean mouseDrag(Event ev, int x, int y) {
        mx = x;
        my = y;
        if (mhithb!=null) {
            switch (mhithb.type) {
                case hb.MENU:
                    redraw();
                    menubar.dropMenu(mhithb, x, y);
                    displayGraphics();
                    break;
                case hb.MAIN:
                    ((painthb) mhithb).mouseDrag(ev,x,y);
                    ((painthb) mhithb).draw(cg);
                    break;
                case hb.MENUBAR:
                    break;
                default:
                    mhithb.mouseDrag(ev,x,y);
                    mhithb.draw(cg);
            }
            
        }

        return true;
    }

    public boolean mouseUp(Event ev, int x, int y) {
        mx = x;
        my = y;
        if (mhithb!=null) {
            switch (mhithb.type) {
                case hb.MENU:
                    redraw();
                    THMenuItem mitem = menubar.dropMenu(mhithb,x,y);
                    displayGraphics();
                    if (mitem!=null) {
                        System.out.println("got: "+mitem.getName());
                        mitem.actuate();
                    }
                    break;
                case hb.MAIN:
                    ((painthb) mhithb).mouseUp(ev,x,y);
                    // ((painthb) mhithb).draw(cg);
                    break;
                case hb.MENUBAR:
                    break;
                default:
                    mhithb.mouseUp(ev,x,y);
            }
        }

        mhithb = null;
        
        redraw();
        displayGraphics();
        return true;
    }

    public static int[] reportMousePos() {
        int[] res = {mx, my};
        return res;
    }
    
    /**----------------------------------
     * This method handles all key actions
     * ---------------------------------- */

    public boolean keyDown(Event ev, int k)
    {
        if(mainhb.keyDown(ev,k))
        {
            redraw();
            displayGraphics();
        }
        return true;
    }

    
    /** --------------------------------
    * These methods are all used to handle the drawing and buffering of the drawn image
    *  -------------------------------- */
    
    public void redraw()
    {
        gi.setColor(Color.gray);
        gi.fillRect(0,0,cbw,cbh);
        gi.setColor(Color.black);
        gi.drawRect(0,0,cbw,cbh);

        ((hb) bh.get("menubar")).draw(gi);
        ((hb) bh.get("main")).draw(gi);
        ((hb) bh.get("icon")).draw(gi);
        ((hb) bh.get("color")).draw(gi);
    }

    public void displayGraphics()
    {
        cg.drawImage(im,0,0,this);
    }

    public void update(Graphics g)
    {
        paint(g);
    }

    public void paint (Graphics g) {
        Rectangle cb = this.bounds();
        System.out.println("got paint message");

        cbw = cb.width;
        cbh = cb.height;
        if (cbw>1) { // There needs to be at least a pixel's width of space
            if (im==null) {
                // This instantiates all of the items within the applet if the image has not been created
                // yet
                im = createImage(cbw,cbh);
                gi = im.getGraphics();
                cg = g.create();

                appendhb(menubar = new Menubar());
                appendhb(ib = new iconhb("icon",8,30,53,221,11,this));
                appendhb(mainhb = new painthb("main",80,30,cbw-100,cbh-80,10,this));
                appendhb(colhb = new colorhb("color",8,ib.ch+40,53,53,11,this,true));
                checkBounds(ib.cw + mainhb.cw + 40, ib.ch + colhb.ch + 40);
                ib.setTarget(mainhb);
                colhb.setTarget(mainhb);
                initMenus();
            }
        } else return;

        redraw();
        displayGraphics();
    }

    public void checkBounds(int width, int height) {
        if (width > cbw) {
            cbw = width;
        }
        if (height > cbh) {
            cbh = height;
        }
    }

    /**
     * This internal class is used to draw and control the menubar of the Treehouse Studio Application
     */
    public class Menubar extends hb {

        private int fsize = 12;
        private int menuPos;

        private int space = 8; // spacing between each THMenu

        /**
            * This instantiates the menu that is to be drawn in the specified Graphics object
         */
        public Menubar() {
            super("menubar", 0, 0, cbw, mbarh, hb.MENUBAR);
            gi.setFont(menufont = new Font("Helvetica",Font.BOLD,fsize));
            fm = gi.getFontMetrics();

            menuPos = space;
        }

        /**
            * This draws the menus when the main application recognizes mouse activity
         */
        public void draw(Graphics gi)
        {
            gi.setColor(Color.white);
            gi.fillRect(0,0,cbw,mbarh);
            gi.setColor(Color.black);
            gi.drawLine(0,mbarh,cbw,mbarh);

            gi.setFont(menufont);

            for (int i = 0; i < children.size(); i++) {
                ((THMenu) children.get(i)).draw(gi);
            }
        }

        /**
            * This method adds the THMenu to this menubar by first creating an instance of a THMenu and then
         * placing it properly with all the other Menus.  This method also returns the THMenu instantiated.
         **/
        public THMenu addMenu(String s) {
            int xw = 0;
            THMenu result = new THMenu(s, menuPos, 0, xw = (fm.stringWidth(s)+space*2), mbarh);
            menuPos += xw;

            this.addChild(result);
            return result;
        }

        /**
            * This displays the menuitems when the main application recognizes mouse activity on the
         * particular menu specified in the arguments.
         */
        public THMenuItem dropMenu(hb m, int mx, int my)
        {
            int i;
            THMenuItem mitem =null;

            gi.setFont(menufont);

            // highlight menu
            gi.setColor(Color.black);
            m.fill(gi);
            gi.setColor(Color.white);
            m.placeString(gi);

            // unfold relevant menu

            THMenu currMenu = (THMenu) childrenht.get(m.cs);
            mitem = currMenu.unfold(gi);

            return mitem;
        }
    }
}
