//
//  iconhb.java
//  treehousedraw_max
//
//  Created by Maxwell Planck on Fri Oct 25 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.applet.*;
import java.util.*;

/**
 * This hb holds the tool menu for selecting what kind of painting tool one wants
 * to use
 */

class iconhb extends hb // icon area
{

    /***********************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** All of the following code can be modified to update the current Tree House Studio
    ** Applet so functionality can be added to the iconhb
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/

    // The following static final ints represent the type of icon selected that should be
    // reflected in the mainhb. Note that the number for the assigned integer does have an
    // effect on it's position in the icon bar. Just make sure that all assigned values are unique.
    // and consecutive starting from 0. To add an icon function, replace one of the icon values
    // here or add on an icon value at the bottom of the list.  Then add an addIcon call in
    // initIcons with the location of the icon image (from the code base directory) as well
    // as the integer variable associated with that icon.
    
    public static final int LASSO = 0;
    public static final int MARQUEE = 1;
    public static final int HAND = 2;
    public static final int TYPE = 3;
    public static final int BUCKET = 4;   
    public static final int SPRAY = 5;
    public static final int BRUSH = 6;
    public static final int PENCIL = 7;
    public static final int LINE = 8;
    public static final int ERASER = 9;
    public static final int RECT = 10;
    public static final int RECTFILL = 11;
    public static final int RERECT = 12;
    public static final int FRERECT = 13;
    public static final int OVAL = 14;
    public static final int OVALFILL = 15;
    public static final int BLOB = 16;
    public static final int FBLOB = 17;
    public static final int POLY = 18;
    public static final int FPOLY = 19;
    
    public void initIcons() {
        this.addIcon("painticon-1_blob.gif", BLOB);
        this.addIcon("painticon-1_brush.gif", BRUSH);
        this.addIcon("painticon-1_bucket.gif", BUCKET);
        this.addIcon("painticon-1_circle.gif", OVAL);
        this.addIcon("painticon-1_eraser.gif", ERASER);
        this.addIcon("painticon-1_fblob.gif", FBLOB);
        this.addIcon("painticon-1_fcircle.gif", OVALFILL);
        this.addIcon("painticon-1_fpoly.gif", FPOLY);
        this.addIcon("painticon-1_frect.gif", RECTFILL);
        this.addIcon("painticon-1_frerect.gif", FRERECT);
        this.addIcon("painticon-1_hand.gif", HAND);
        this.addIcon("painticon-1_lasso.gif", LASSO);
        this.addIcon("painticon-1_line.gif", LINE);
        this.addIcon("painticon-1_pencil.gif", PENCIL);
        this.addIcon("painticon-1_poly.gif", POLY);
        this.addIcon("painticon-1_rect.gif", RECT);
        this.addIcon("painticon-1_rerect.gif", RERECT);
        this.addIcon("painticon-1_spraycan.gif", SPRAY);
        this.addIcon("painticon-1_type.gif", TYPE);
        this.addIcon("painticon-1_marquee.gif", MARQUEE);
    }
    

    /************************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** Everything else beyond this point is internal and shouldn't be changed unless
    ** you want to change an underlying aspect of the Applet.  Do use the rest of this code
    ** to understand how to add to the Applet.
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/
    
    Applet app;
    int sel = 0;
    //   final static String icons[] =
    int rows, cols;
    final int iconW = 27, iconH = 23;
    
    int selx = 1, sely = 1;
    
    long lastt=0;
    int lastsel;

    MediaTracker mt;
    Vector icons;
    Vector iconStrings;
    
    public iconhb(String _s, int _x, int _y, int _w, int _h, int _type, Applet _app)
    {
        super(_s,_x,_y,_w,_h,_type);
        app = _app;
        mt = new MediaTracker(app);

        iconStrings = new Vector();
        initIcons();
        icons = retrieveIcons();
        cols = 2;
        rows = (int) Math.ceil(icons.size()/2.0);

        // This updates the super variables
        ch = rows*iconH;
        cw = cols*iconW;
    }

    public void addIcon(String s, int ind) {
        if (iconStrings.size() <= ind) {
            iconStrings.setSize(ind+1);
        }
        iconStrings.set(ind, s);
    }

    private Vector retrieveIcons() {
        Vector res = new Vector();
        for (int i = 0; i < iconStrings.size(); i++) {
            Image im = app.getImage(app.getCodeBase(), "painticons/" + iconStrings.get(i));
            im = im.getScaledInstance(iconW,iconH,Image.SCALE_SMOOTH);
            if (im.getHeight(app) != -1) { // This should be == 1
                throw new RuntimeException("The icon referring to image " + iconStrings.get(i) + " was not loaded properly");
            }
            System.out.println(im.getWidth(app) + ", " + im.getHeight(app));
            mt.addImage(im,i);
            res.add(im);
        }

        try {
            mt.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return res;
    }

    public void draw(Graphics g) {
        for (int i = 0; i < icons.size(); i++) {
            g.drawImage((Image) icons.get(i),cx+(i%2*(iconW)),cy+(int) (Math.floor(i/2))*(iconH), app);
        }
        g.setColor(Color.blue);
        g.drawRect(cx+1+selx*iconW,cy+1+sely*iconH,iconW-3,iconH-3);
    }
    
    public void mouseDown(Event ev, int mx, int my) {
        mx-=cx; my-=cy;
        sely = my/iconH;
        selx = mx/iconW;
        sel = selx+sely*cols;

        long t = System.currentTimeMillis();

        if (t-lastt<500 && lastsel == sel) {
            target.message(painthb.DCLICK,new Integer(sel));
        } else
            target.message(painthb.TOOL,new Integer(sel));
        lastt = t;
        lastsel = sel;
    }
}

