//
//  painthb.java
//  Treehousestudio
//
//  Created by john maeda on Thu Aug 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//


import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.image.*;

import cgio;
import paintbrush;
import hb;

/**
* This wrapper class rasterizes the image drawn on the screen into a byte array.  Currently, this method
 * saves the image by using an index table.  This implementation saves space but costs a little processing time
 * on saving and opening.
 */
class imio
{
    public int []graster=null;
    byte []vs=null;
    int []idat = null;
    Image datim;

    int w, h;

    public imio(int _w, int _h)
    {
        w = _w; h = _h;
    }

    public Image imagegraster(Applet app)
    {
        DirectColorModel dm;
        MemoryImageSource ms;
        int i,j,k;

        // should just do a newimage and cache the image ...
        // PROBLEM ***************** makes too many images

        dm = new DirectColorModel(24,0xff0000,0xff00,0xff);

        ms = new MemoryImageSource(w,h,dm,graster,0,w);
        ms.setAnimated(false);
        datim = app.createImage(ms);
        return datim;
    }

    public Image dataimage(byte []b, int len, Applet app)
    {
        DirectColorModel dm;
        MemoryImageSource ms;
        int i,j,k;

        // should just do a newimage and cache the image ...
        // PROBLEM ***************** makes too many images

        dm = new DirectColorModel(24,0xff0000,0xff00,0xff);
        if (idat == null) idat = new int[w*h*3];

        for(j=0,k=0;j<h;j++)
            for(i=0;i<w;i++,k++) {
                idat[k] = ((0xff&b[i*3+j*3*w])<<16)| ((0xff&b[i*3+j*3*w+1])<<8) |  (0xff&b[i*3+j*3*w+2]);
            }

                ms = new MemoryImageSource(w,h,dm,idat,0,w);
        ms.setAnimated(true);
        datim = app.createImage(ms);
        return datim;
    }

    public boolean dorasterize(Image img)
    {

        //         System.out.println("rasterizing: "+w+"/"+h);
        if (graster==null) graster = new int[w*h];
        if (graster.length<w*h) {graster=null;graster = new int[w*h];}

        int[]  pixels  =  graster;
        PixelGrabber  pg  =
            new  PixelGrabber(img,  0,  0,  w,  h,  pixels,  0,  w);
        try  {
            pg.grabPixels();
        }  catch  (InterruptedException  e)  {
            System.err.println("interrupted  waiting  for  pixels!");
            return false;
        }
        if  ((pg.status()  &  ImageObserver.ABORT)  !=  0)  {
            System.err.println("image  fetch  aborted  or  errored");
            return false;
        }
        //       System.out.println("rasterized");
        return true;
    }

    public byte[] rasterizeim(Image img)  {
        if (!dorasterize(img)) {
            System.out.println("Rasterization didn't work");
            return null;
        }
        // Header Offset of bytes gives room to attach width and height
        int h_offset = 48;
        int h_offset_i = 4+256*3;

        if (vs == null) {
            vs = new byte[h_offset + w*h*3];
        }

        byte[] vsi = new byte[h_offset + w*h];

        vs[0] = (byte) ((w >> 8) & 0xFF);
        vs[1] = (byte) (w & 0xFF);
        vs[2] = (byte) ((h >> 8) & 0xFF);
        vs[3] = (byte) (h & 0xFF);

        System.out.println("Width of Image: " +(((vs[0] & 0xFF) << 8) | (vs[1] & 0xFF)) + " px");
        System.out.println("Height of Image:  " +(((vs[2] & 0xFF) << 8) | (vs[3] & 0xFF)) + " px");

        int[] pxObserver = new int[256];
        // Holds the header of the array index
        int pxpointer = 0;
        // Reports the position of the pixel in the index array
        int pxpos = 0;

        for  (int  j  =  0;  j  <  h;  j++)  {
            for  (int  i  =  0;  i  <  w;  i++)  {
                // look at the pixel
                //System.out.print(pixels[j*w+i] +" ");
                //                  handleSinglePixel(x+i, y+j, pixels[j * w + i]);
                int pixel =  graster[j * w + i];
                int  alpha  =  (pixel  >>  24)  &  0xff;
                int  red      =  (pixel  >>  16)  &  0xff;
                int  green  =  (pixel  >>    8)  &  0xff;
                int  blue    =  (pixel            )  &  0xff;

                // the following code maintains how many different colors are in the image
                // this creates the image index

                // assume that this is a new color
                boolean isNewColor = true;
                for (int k = 0; k <= pxpointer; k++) {
                    if (pxObserver[k] == pixel) {
                        pxpos = k;
                        isNewColor = false;
                        break;
                    }
                }
                if (isNewColor) {
                    pxpointer++;
                    pxpos = pxpointer;
                    pxObserver[pxpointer] = pixel;
                    System.out.println(pixel + " ---- " +pxpointer);

                    vsi[pxpointer*3+0] = (byte)(0xff&red);
                    vsi[pxpointer*3+1] = (byte)(0xff&green);
                    vsi[pxpointer*3+2] = (byte)(0xff&blue);
                }

                vsi[h_offset + i+j*w] = (byte)(0xff&pxpos);

                vs[h_offset+(i*3+j*w*3+0)] = (byte)(0xff&red);
                vs[h_offset+(i*3+j*w*3+1)] = (byte)(0xff&green);
                vs[h_offset+(i*3+j*w*3+2)] = (byte)(0xff&blue);
            }
        }

        return vs;
    }
}

/**
* This class performs all of the drawing performed in the Applet.  It also handles saving itself.
 */
public class painthb extends hb
{

    final static int TOOL = 1,
    FGCOLOR = 2,
    BGCOLOR = 3,
    DCLICK = 4;

    int lastmx, lastmy;
    int startmx, startmy;
    int lastpolymx, lastpolymy;
    Image imstk;
    Graphics gstk;

    boolean pushedp = false;
    boolean isDrawingPoly = false;
    
    int mode = iconhb.PENCIL;
    

    /**
     * In order to add a tool to the Applet, the following four methods must be updated so that the Applet knows
     * what to do when a tool is  selected (message), when the mouse is clicked (mouseDown), when the mouse is
     * dragging (mouseDrag), and when the mouse is let up (mouseUp).
     **/
    public void message(int fromWho, Object odat)
    {
        switch(fromWho) {
            case TOOL:
                // before change mode
                if (mode == iconhb.TYPE) {
                    textfreeze();
                }

                // mode change
                mode = ((Integer)odat).intValue();
                switch(mode) {
                    case iconhb.PENCIL:
                        curbsh = sbsh.setsize(1);
                        break;
                    case iconhb.TYPE:
                        keystr=""; keyx = -1; keyy = -1;
                        break;
                    case iconhb.BRUSH:
                        //               curbsh = ibsh[0];
                        curbsh = sbsh.setsize(10);
                        break;
                    case iconhb.LINE:
                        curbsh = sbsh.setsize(2);
                        break;
                    case iconhb.RECT:
                        curbsh = sbsh.setsize(2);
                        break;
                    case iconhb.OVAL:
                        curbsh = sbsh.setsize(2);
                        break;
                    case iconhb.RECTFILL:
                        curbsh = sbsh.setsize(2);
                        break;
                    case iconhb.ERASER:
                        curbsh = sbsh.setsize(16);
                        break;
                    case iconhb.FBLOB:
                        curbsh = sbsh.setsize(2);
                        break;
                    case iconhb.BLOB:
                        curbsh = sbsh.setsize(1);
                        break;
                    case iconhb.POLY:
                        curbsh = sbsh.setsize(1);
                        break;
                    default:
                        break;
                }
                    //            System.out.println("mode is: "+dat);
                    break;
            case FGCOLOR: // fgcol change
                fgcol = (Color)odat;
                break;
            case BGCOLOR: // bgcol change
                bgcol = (Color)odat;
                break;
            case DCLICK: // double click
                mode = ((Integer)odat).intValue();
                System.out.println("doubleclick");
                switch(mode) {
                    case iconhb.ERASER:
                        clearbuffer();
                        break;
                    default:
                        break;
                }
                default:
                    break;
        }
    }

    public void mouseDown(Event ev, int mx, int my) {

        // draw as normal
        mx-=cx; my-=cy;

        lastmx = mx; lastmy = my;
        startmx = mx; startmy = my;

        cacheundo();
        
        switch(mode) {
            case iconhb.TYPE:
                textfreeze();
                keyx = mx; keyy = my;
                keystr="";
                break;
            case iconhb.SPRAY:
                gi.setColor(fgcol);
                dospray(gi,mx,my);
                break;
            case iconhb.ERASER:
                gi.setColor(fgcol);
                gi.setColor(Color.white);
            case iconhb.PENCIL:
            case iconhb.BRUSH:
                gi.setColor(fgcol);
                gi.setColor(fgcol);
                line(gi,lastmx,lastmy,mx,my);
                break;
            case iconhb.LINE:
                gi.setColor(fgcol);
                push();
                line(gi,startmx,startmy,mx,my);
                break;
            case iconhb.RECT:
                gi.setColor(fgcol);
                push();
                rectadjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.RECTFILL:
                gi.setColor(fgcol);
                cacheundo();
                push();
                rectfilladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.OVAL:
                gi.setColor(fgcol);
                push();
                ovaladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.OVALFILL:
                gi.setColor(fgcol);
                push();
                ovalfilladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.BUCKET:
                gi.setColor(fgcol);
                floodfill(mx,my);
            case iconhb.FBLOB:
            case iconhb.BLOB:
                gi.setColor(fgcol);
                line(gi,lastmx,lastmy,mx,my);
                break;
            case iconhb.POLY:
                gi.setColor(fgcol);
                isDrawingPoly = true;
                if (checkDoubleClick()) {
                    line(gi,mx,my,startmx,startmy);
                    isDrawingPoly = false;
                }
                line(gi,lastpolymx,lastpolymy,mx,my);
                lastpolymx = mx; lastpolymy = my;
                break;
            default:
                break;
        }
    }

    /**
     * For this method, if gi.drawImage(imstk,0,0,app) is called before anything is drawn to the graphic, the state
     * of the canvas before the tool was begun (mouse was clicked) is drawn before the resulting drag action is
     * drawn on top of it.  For example, when drawing a line, if this method is not invoked, the line would draw
     * to the actual canvas every time the mouse is dragged, resulting in messiness.
     */
    public void mouseDrag(Event ev, int mx, int my) {
        mx-=cx; my-=cy;

        switch(mode) {
            case iconhb.SPRAY:
                gi.setColor(fgcol);
                dospray(gi,mx,my);
                break;
            case iconhb.ERASER:
                gi.setColor(Color.white);
            case iconhb.PENCIL: //Pencil behaves just like a Brush
            case iconhb.BRUSH:
                gi.setColor(fgcol);
                line(gi,lastmx,lastmy,mx,my);
                break;
            case iconhb.LINE:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                line(gi,startmx,startmy,mx,my);
                break;
            case iconhb.RECT:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                rectadjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.RECTFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                rectfilladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.OVAL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                ovaladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.OVALFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                ovalfilladjusted(gi,startmx,startmy,mx,my);
                break;
            case iconhb.FBLOB:
            case iconhb.BLOB:
                gi.setColor(fgcol);
                line(gi,lastmx,lastmy,mx,my);
                break;
            case iconhb.POLY:
                gi.setColor(fgcol);
                line(gi,startmx,startmy,mx,my);
                break;
            default:
                break;
        }

        lastmx=mx; lastmy = my;
    }

    public void mouseMoved(Event ev, int mx, int my) {
        switch(mode) {
            case iconhb.POLY:
                if (isDrawingPoly) {
                    gi.setColor(fgcol);
                    line(gi,startmx,startmy,mx,my);
                }
                break;
            default:
                break;
        }
    }
    
    public void mouseUp(Event ev, int mx, int my) {
        mx-=cx; my-=cy;
        gi.setColor(fgcol);

        switch(mode) {
            case iconhb.SPRAY:
                gi.setColor(fgcol);
                dospray(gi,mx,my);
                break;
            case iconhb.ERASER:
                gi.setColor(Color.white);
            case iconhb.PENCIL:
            case iconhb.BRUSH:
                gi.setColor(fgcol);
                line(gi,lastmx,lastmy,mx,my);
                break;
            case iconhb.LINE:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                line(gi,startmx,startmy,mx,my);
                pop();
                break;
            case iconhb.RECT:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                rectadjusted(gi,startmx,startmy,mx,my);
                pop();
                break;
            case iconhb.RECTFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                rectfilladjusted(gi,startmx,startmy,mx,my);
                pop();
                break;
            case iconhb.OVAL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                ovaladjusted(gi,startmx,startmy,mx,my);
                pop();
                break;
            case iconhb.OVALFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                ovalfilladjusted(gi,startmx,startmy,mx,my);
                pop();
                break;
            case iconhb.BLOB:
                gi.setColor(fgcol);
                line(gi,mx,my,startmx,startmy);
                break;
            case iconhb.FBLOB:
                gi.setColor(fgcol);
                line(gi,mx,my,startmx,startmy);
                break;
            case iconhb.POLY:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                line(gi,startmx,startmy,mx,my);
                startmx = mx;
                startmy = my;
            default:
                break;
        }
    }

    Image im;
    Graphics gi;

    Image imundo;
    Graphics giu;

    Image imtmp;
    Graphics git;

    Applet app;
    paintbrush curbsh;
    roundbrush rbsh;
    squarebrush sbsh;
    imbrush ibsh[] = new imbrush[16];

    int dimbrush = 10;
    int dimlw = 4;
    Color fgcol=Color.black, bgcol=Color.white;

    Font keyfont;
    int keysz = 18; // font size
    int keyld=24; // leading
    int keyx=-1, keyy=-1;
    String keystr="";

    cgio cg = null;
    imio imdat =null;

    /**
        * This is the main component of the TreeHouse Draw application.  This is essentially the canvas in which all
     * drawing, painting, erasing, etc. occurs.
     */
    public painthb(String _s, int _x, int _y, int _w, int _h, int _type, Applet _app)
    {
        super(_s,_x,_y,_w,_h,_type);

        curbsh = sbsh = new squarebrush(1);

        rbsh = new roundbrush(dimbrush);

        app = _app;
        im = app.createImage(cw,ch);
        gi = im.getGraphics();

        imtmp = app.createImage(cw,ch);
        git = imtmp.getGraphics();

        imundo = app.createImage(cw,ch);
        giu = imundo.getGraphics();

        keyfont = new Font("Helvetica",Font.BOLD,keysz);
        newbuffer();

        // build brushes
        MediaTracker mt = new MediaTracker(app);
        Image im;

        im = app.getImage(app.getCodeBase(),"brushes/16.gif");
        mt.addImage(im,1);
        try {
            mt.waitForAll();
        } catch (Exception e)
        {}
        ibsh[0] = new imbrush(16,im,app);

    }

    public void clearbuffer()
    {
        cacheundo();
        gi.setColor(Color.white);
        gi.fillRect(0,0,cw,ch);
        gi.setColor(Color.black);
    }

    public void newbuffer()
    {
        gi.setColor(Color.white);
        gi.fillRect(0,0,cw,ch);
        gi.setColor(Color.black);

        giu.setColor(Color.white);
        giu.fillRect(0,0,cw,ch);
        giu.setColor(Color.black);
    }

    public void push() // can only do once
    {
        if (pushedp) {
            err("can't push more than once");
            return;
        }
        // swap buffers
        imstk = im; gstk = gi;
        git.drawImage(im,0,0,app);
        im = imtmp; gi = git;
        pushedp = true;
    }

    public void pop() // can only do once
    {
        if (!pushedp) return;
        // restore buffers
        im = imstk; gi = gstk;
        gi.drawImage(imtmp,0,0,app);
        pushedp = false;
    }

    public void cacheundo()
    {
        giu.drawImage(im,0,0,app);
    }

    public void doundo()
    {
        System.out.println("doing undo");
        git.drawImage(im,0,0,app);
        gi.drawImage(imundo,0,0,app);
        giu.drawImage(imtmp,0,0,app); // swap images effectively
    }

    public void drawkeystr(Graphics g, int ox, int oy, boolean tempp)
    {
        /* PROBLEM need to not wrap on newline as then can't have blanke lines!
        */
        StringTokenizer st = new StringTokenizer(keystr,"\n");
        int x, y;
        int len=0;
        String s;
        int lc=0;
        if (keyx == keyy && keyx == -1) return;
        g.setFont(keyfont);
        x = keyx+ox; y = keyy+oy;
        g.setColor(fgcol);
        while(st.hasMoreTokens()) {
            g.drawString(s=st.nextToken(),x,y);
            len = g.getFontMetrics().stringWidth(s);
            y+=keyld; lc++;
        }
        if (lc>0)
            y-=keyld;
        if (tempp) {
            g.fillRect(x+len+2,y-2,3,3);
        }
    }

    public void textfreeze()
    {
        drawkeystr(gi,0,0,false);
        // textfreeze(gi);
    }

    public boolean keyDown(Event ev, int k)
    {
        if (mode == iconhb.TYPE) {
            //         System.out.println("key is: "+k);
            if (k == 8) { // backup
                int l = keystr.length();
                if (l>0)
                    keystr = keystr.substring(0,l-1);
            } else {
                keystr+=(char)k;
            }
            return true;
        }
        return false;
    }


    public void setlw(int lw)
    {
        curbsh.setsize(lw);
    }

    public void rectadjusted(Graphics g, int x1, int y1, int x2, int y2)
    {
        int x,y;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }
        line(g,x1,y1,x2,y1);
        line(g,x1,y2,x2,y2);
        line(g,x1,y1,x1,y2);
        line(g,x2,y1,x2,y2);
    }

    public void rectfilladjusted(Graphics g, int x1, int y1, int x2, int y2)
    {
        int x,y;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        g.setColor(bgcol);
        g.fillRect(x1,y1,x2-x1,y2-y1);
        g.setColor(fgcol);
        rectadjusted(g,x1,y1,x2,y2);
    }

    public void ovaladjusted(Graphics g, int x1, int y1, int x2, int y2)
    {
        int x,y;
        int w,h;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        w = (x2-x1)/2;h=(y2-y1)/2;

        ellipse(g,x1+w,y1+h,w,h);
    }

    public void ovalfilladjusted(Graphics g, int x1, int y1, int x2, int y2)
    {
        int x,y;
        int w,h;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        w = (x2-x1)/2;h=(y2-y1)/2;

        g.setColor(bgcol);
        fillellipse(g,x1+w,y1+h,w,h);
        g.setColor(fgcol);
        ellipse(g,x1+w,y1+h,w,h);
    }

    public void dot(Graphics g, int x, int y)
    {
        g.drawLine(x,y,x,y);
    }

    Random ran = new Random();

    public void dospray(Graphics g, int x, int y)
    {
        int i;
        for(i=0;i<50;i++) {
            dot(g,x+(int)(ran.nextGaussian()*8),y+(int)(ran.nextGaussian()*8));
        }
    }


    /**
        * The following two methods handle the saving and opening of files within the DB
     */

    public void dosave(Graphics g, Applet app)
    {
        String filename;

        // This rasterizes the drawn image into a byte array
        // that is saved into the db as binary information
        if (imdat==null)
            imdat = new imio(cw,ch);
        byte[] b = imdat.rasterizeim(im);

        filename="BLANK FOR NOW";

            if (cg==null) cg = new cgio(app);
        cg.dosend(b,b.length,filename);
    }

    public void doopen(Graphics g, Applet app)
    {

        // This does nothing right now
    }

    /**
        * This method (called from the menu) allows the user to resize the canvas by dragging
     * any corner to the limits of the applet.
     */
    public void doresize(Graphics g, Applet app) {
        System.out.println("Should allow the painting region to be resized");
    }

    public void draw(Graphics g)
    {
        int i;
        //      System.out.println("drew it\n");
        Rectangle r = g.getClipBounds();
        g.setClip(cx,cy,cw,ch);
        g.drawImage(im,cx,cy,cw,ch,app);
        if (mode == iconhb.TYPE) {
            drawkeystr(g,cx,cy,true);
        }
        g.setClip(r.x,r.y,r.width,r.height);
        g.setColor(Color.black);g.drawRect(-1+cx,-1+cy,cw+2,ch+2);
    }


    /**
     * All of the following methods are used to implement the tools
     */

    /**
     * This method checks to see if the user double clicked on the canvas
     */
    public boolean checkDoubleClick() {
        return false;
    }
        
    public void line(Graphics g, int ox1, int oy1, int ox2, int oy2) {
        int dx, dy, incrE, incrNE, d, x, y, twoV, sdx=0, sdy=0;
        float invDenom, twoDX, scratch, slope;
        int x1, x2, y1, y2, incy=0, incx=0, which;
        boolean backwards = false, slopeDown = false;
        /* first do horizontal line */
        if(ox1==ox2) {
            x = ox1;
            if(oy1 < oy2) { y1 = oy1; y2 = oy2; }
            else { y1 = oy2; y2 = oy1; }
            for(y=y1;y<=y2;y++) {
                curbsh.paint(g,x, y);
            }
            return;
        }
        slope = (float)(oy2 - oy1)/(float)(ox2 - ox1);
        /* check for which 1, 0 <= slope <= 1 */
        if(slope >= 0 && slope <= 1) which = 1;
        else if(slope > 1) which = 2;
        else if(slope < -1) which = 3;
        else which=4;
        if(((which==1 || which==2 ||which==4) && ox1 > ox2) || ((which==3) && ox1 < ox2)) {
            x1 = ox2;
            x2 = ox1;
            y1 = oy2;
            y2 = oy1;
        }
        else {
            x1 = ox1;
            y1 = oy1;
            x2 = ox2;
            y2 = oy2;
        }
        dx = x2 - x1;
        dy = y2 - y1;
        if(which==1) {
            sdx = dx;
            d = 2 * dy - dx;
            incy = 1;
            incrE = 2*dy;
            incrNE = 2*(dy-dx);
        }
        else if(which==2) {
            sdy = dy;
            d = 2 * dx - dy;
            incx = 1;
            incrE = 2*dx;
            incrNE = 2*(dx-dy);
        }
        else if(which==3) {
            sdy = -dy;
            d = -2 * dx - dy;
            incx = -1;
            incrE = -2*dx;
            incrNE = -2*(dx+dy);
        }
        else /*if(which == 4)*/ {
            sdx = -dx;
            d = -2 * dy - dx;
            incy = -1;
            incrE = -2*dy;
            incrNE = -2*(dy+dx);
        }
        if(which==1 || which==4) {
            twoV = 0;
            invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
            twoDX = 2 * sdx * invDenom;
            x = x1;
            y = y1;
            curbsh.paint(g,x, y);
            while(x < x2) {
                if(d<0) {
                    twoV = d + dx;
                    d += incrE;
                    ++x;
                }
                else {
                    twoV = d - dx;
                    d += incrNE;
                    ++x;
                    y+=incy;
                }
                scratch = twoV * invDenom;
                curbsh.paint(g,x, y);
            }
        }
        else {
            twoV = 0;
            invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
            twoDX = 2 * sdy * invDenom;
            x = x1;
            y = y1;
            curbsh.paint(g,x, y);
            while(y < y2) {
                if(d<0) {
                    twoV = d + dy;
                    d += incrE;
                    ++y;
                }
                else {
                    twoV = d - dy;
                    d += incrNE;
                    ++y;
                    x+=incx;
                }
                scratch = twoV * invDenom;
                curbsh.paint(g,x, y);
            }
        }
    }

    public void Fill4EllipsePoints(Graphics g,int CX, int CY, int x, int y)
    {

        g.drawLine(CX+x,CY+y,CX+x,CY-y);
        g.drawLine(CX-x,CY+y,CX-x,CY-y);
        g.drawLine(CX-x,CY+y,CX+x,CY+y);
        g.drawLine(CX-x,CY-y,CX+x,CY-y);
    }

    public void fillellipse(Graphics g, int CX, int CY, int XRadius, int YRadius)
    {
        int X, Y,XChange, YChange,EllipseError,TwoASquare, TwoBSquare,StoppingX, StoppingY;

        if (XRadius==0&&XRadius==YRadius) {
            line(g,CX,CY,CX,CY); return;
        }

        if (XRadius==0) {
            line(g,CX,CY-YRadius,CX,CY+YRadius); return;
        }
        if (YRadius==0) {
            line(g,CX-XRadius,CY,CX+XRadius,CY); return;
        }

        TwoASquare = 2*XRadius*XRadius;
        TwoBSquare = 2*YRadius*YRadius;
        X = XRadius;
        Y = 0;
        XChange = YRadius*YRadius*(1-2*XRadius);
        YChange = XRadius*XRadius;
        EllipseError = 0;
        StoppingX = TwoBSquare*XRadius;
        StoppingY = 0;
        while ( StoppingX >= StoppingY ) {
            Fill4EllipsePoints(g,CX,CY,X,Y);
            Y++;
            StoppingY+= TwoASquare;
            EllipseError+=YChange;
            YChange+=TwoASquare;
            if ((2*EllipseError + XChange) > 0 ){
                X--;
                StoppingX-= TwoBSquare;
                EllipseError+=XChange;
                XChange+=TwoBSquare;
            }
        }

        X = 0;
        Y = YRadius;
        XChange = YRadius*YRadius;
        YChange = XRadius*XRadius*(1- 2*YRadius);
        EllipseError = 0;
        StoppingX = 0;
        StoppingY = TwoASquare*YRadius;
        while ( StoppingX <=StoppingY ) {
            Fill4EllipsePoints(g,CX,CY,X,Y);
            X++;
            StoppingX+= TwoBSquare;
            EllipseError+=XChange;
            XChange+=TwoBSquare;
            if ((2*EllipseError + YChange) > 0 ) {
                Y--;
                StoppingY-= TwoASquare;
                EllipseError+=YChange;
                YChange+=TwoASquare;
            }
        }
    }

    public void Plot4EllipsePoints(Graphics g,int CX, int CY, int x, int y)
    {
        curbsh.paint(g,CX+x,CY+y);
        curbsh.paint(g,CX-x,CY+y);
        curbsh.paint(g,CX-x,CY-y);
        curbsh.paint(g,CX+x,CY-y);
    }

    public void ellipse(Graphics g, int CX, int CY, int XRadius, int YRadius)
    {
        int X, Y,XChange, YChange,EllipseError,TwoASquare, TwoBSquare,StoppingX, StoppingY;

        if (XRadius==0&&XRadius==YRadius) {
            line(g,CX,CY,CX,CY); return;
        }

        if (XRadius==0) {
            line(g,CX,CY-YRadius,CX,CY+YRadius); return;
        }
        if (YRadius==0) {
            line(g,CX-XRadius,CY,CX+XRadius,CY); return;
        }

        TwoASquare = 2*XRadius*XRadius;
        TwoBSquare = 2*YRadius*YRadius;
        X = XRadius;
        Y = 0;
        XChange = YRadius*YRadius*(1-2*XRadius);
        YChange = XRadius*XRadius;
        EllipseError = 0;
        StoppingX = TwoBSquare*XRadius;
        StoppingY = 0;
        while ( StoppingX >= StoppingY ) {
            Plot4EllipsePoints(g,CX,CY,X,Y);
            Y++;
            StoppingY+= TwoASquare;
            EllipseError+=YChange;
            YChange+=TwoASquare;
            if ((2*EllipseError + XChange) > 0 ){
                X--;
                StoppingX-= TwoBSquare;
                EllipseError+=XChange;
                XChange+=TwoBSquare;
            }
        }

        X = 0;
        Y = YRadius;
        XChange = YRadius*YRadius;
        YChange = XRadius*XRadius*(1- 2*YRadius);
        EllipseError = 0;
        StoppingX = 0;
        StoppingY = TwoASquare*YRadius;
        while ( StoppingX <=StoppingY ) {
            Plot4EllipsePoints(g,CX,CY,X,Y);
            X++;
            StoppingX+= TwoBSquare;
            EllipseError+=XChange;
            XChange+=TwoBSquare;
            if ((2*EllipseError + YChange) > 0 ) {
                Y--;
                StoppingY-= TwoASquare;
                EllipseError+=YChange;
                YChange+=TwoASquare;
            }
        }
    }

    int []pv;
    int pw;
    int ph;

    int ocol;
    int ncol;

    public void pcol(int r)
    {
        System.out.println("rgb: "+((r>>16)&0xff) + "/"+ ((r>>8)&0xff) +"/"+(r&0xff) +"/"+((r>>24)&0xff));
    }
    public void floodfill(int x, int y)
    {
        int r, g, b;

        g = fgcol.getGreen();
        r = fgcol.getRed();
        b = fgcol.getBlue();

        if (imdat==null) imdat = new imio(cw,ch);
        imdat.dorasterize(im);
        pv = imdat.graster; ph = ch; pw = cw;

        ocol = pixelread(x,y);

        //   System.out.println("r: "+r+" g: "+g+" b: "+b);

        ncol = ((r<<16)|(g<<8)|b);

        //     System.out.println("olcol/ncol: "+ocol+"/"+ncol);
        //    pcol(ocol); pcol(ncol);
        ocol =(0xffffff&ocol);

        //      dofill(x,y);
        fill(x,y,ncol);
        // now put buffer back
        gi.drawImage(imdat.imagegraster(app),0,0,app);
    }

    public void dofill(int x, int y)
    {
        //     System.out.println("fill "+x+"/"+y);
        if ((x<0)||(x>=pw)) return;
        if ((y<0)||(y>=ph)) return;

        if ((0xffffff&pixelread(x,y))==ocol) {
            //           System.out.println("pxwr: "+x+"/"+y);
            pixelwrite(x,y,ncol);
            dofill(x+1,y); dofill(x-1,y); dofill(x,y+1); dofill(x,y-1);
        }
    }

    public int pixelread(int x, int y)
    {
        return 0xffffff&pv[x+y*pw];
    }
    public   void pixelwrite(int x, int y, int nv)
    {
        pv[x+y*pw] = nv;
    }

    public int setPixel(int x, int y)
    {
        return pv[x+y*pw];
    }
    public   void getPixel(int x, int y, int nv)
    {
        pv[x+y*pw] = nv;
    }
    class Segment
    {
        public int y,xl,xr,dy;
        public Segment() {super();}
    }

    final static int MAX =10000;		/* max depth of stack */
    int spc=0;

    Segment stack[]=null;
    int wy0, wy1, wx0,wx1;

    public void PUSH(int Y, int XL, int XR, int DY)	/* push new segment on stack */
    {
        if (spc<MAX && Y+(DY)>=wy0 && Y+(DY)<=wy1)
        {stack[spc].y = Y; stack[spc].xl = XL; stack[spc].xr = XR; stack[spc].dy = DY; spc++;}
    }


    public void fill(int x, int y, int nv)
    {
        wx0 = 0; wx1 = cw-1; wy0 = 0; wy1 = ch-1;

        int l=0, x1, x2, dy;
        int ov;	/* old pixel value */

        if (stack==null) {
            stack = new Segment[MAX];
            int i;
            for(i=0;i<MAX;i++) stack[i] = new Segment();
        }
        spc = 0;

        ov = pixelread(x, y);		/* read pv at seed point */
        if (ov==nv || x<wx0 || x>wx1 || y<wy0 || y>wy1) return;
        PUSH(y, x, x, 1);			/* needed in some cases */
        PUSH(y+1, x, x, -1);		/* seed segment (popped 1st) */

        while (spc>0) {
            /* pop segment off stack and fill a neighboring scan line */

            //POP(y, x1, x2, dy);

            spc--;
            dy = stack[spc].dy;
            y = stack[spc].y+dy;
            x1 = stack[spc].xl;
            x2 = stack[spc].xr;

            /*
             * segment of scan line y-dy for x1<=x<=x2 was previously filled,
             * now explore adjacent pixels in scan line y
             */
            for (x=x1; x>=wx0 && pixelread(x, y)==ov; x--)
                pixelwrite(x, y, nv);

            if (x>=x1) {
                boolean skipp = true;
                do {
                    if (!skipp) {
                        for (; x<=wx1 && pixelread(x, y)==ov; x++) pixelwrite(x, y, nv);
                        PUSH(y, l, x-1, dy);
                        if (x>x2+1) PUSH(y, x2+1, x-1, -dy);	/* leak on right? */
                    }
                    for (x++; x<=x2 && pixelread(x, y)!=ov; x++); skipp = false;
                    l = x;
                } while (x<=x2);
                continue;
            }

            l = x+1;
            if (l<x1) PUSH(y, l, x1-1, -dy);		/* leak on left? */
            x = x1+1;
            do {
                for (; x<=wx1 && pixelread(x, y)==ov; x++)
                    pixelwrite(x, y, nv);
                PUSH(y, l, x-1, dy);
                if (x>x2+1) PUSH(y, x2+1, x-1, -dy);	/* leak on right? */
                for (x++; x<=x2 && pixelread(x, y)!=ov; x++);
                l = x;
            } while (x<=x2);
        }

    }

    /*
     public void fillFast(int x, int y, int fill)
     {
         if ((x < 0) || (x >= pw)) return;
         if ((y < 0) || (y >= ph)) return;
         int old = raster.getPixel(x, y);
         if (old == fill) return;
         raster.setPixel(fill, x, y);
         fillEast(x+1, y, fill, old);
         fillSouth(x, y+1, fill, old);
         fillWest(x-1, y, fill, old);
         fillNorth(x, y-1, fill, old);
     }

     private void fillEast(int x, int y, int fill, int old)
     {
         if (x >= pw) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillSouth(x, y+1, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }

     private void fillSouth(int x, int y, int fill, int old)
     {
         if (y >= ph) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillSouth(x, y+1, fill, old);
             fillWest(x-1, y, fill, old);
         }
     }

     private void fillWest(int x, int y, int fill, int old)
     {
         if (x < 0) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillSouth(x, y+1, fill, old);
             fillWest(x-1, y, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }

     private void fillNorth(int x, int y, int fill, int old)
     {
         if (y < 0) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillWest(x-1, y, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }   */

}
